[![License: GPLv3+](https://archive.org/download/libreweb/license.svg)](https://www.gnu.org/licenses/gpl-3.0.txt)

# Livie is Video in Emacs

![screenshot](screenshot.png)

Livie allows the user to search youtube.com and play the video from `mpv`.

## Requirements

- `hypervideo`
- `curl`
- `mpv`

  `sudo pacman -S mpv curl hypervideo`

## Installation

``` emacs-lisp
(push (concat user-emacs-directory "path/to/livie") load-path)
(let* ((file-name-handler-alist nil))
  (require 'livie))
```

## Installation in emacs-personal

Create new dir:

    mkdir ~/.emacs.d/private/

Clone repo:

    git clone https://git.sr.ht/~heckyel/livie ~/.emacs.d/private/livie

Open `settings.el` write the following:

``` emacs-lisp
(push (concat user-emacs-directory "private/livie") load-path)
(let* ((file-name-handler-alist nil))
  (require 'livie))
```

## Usage
Just run `M-x livie` and enter a search query.
Puts it in `livie-mode`. Some of the ways you can interact
with the buffer are shown below.

| key            | binding                      | description                                           |
|----------------|------------------------------|-------------------------------------------------------|
| <kbd>n</kbd>   | `next-line`                  | Move cursor to next line                              |
| <kbd>p</kbd>   | `previous-line`              | Move cursor to previous line                          |
| <kbd>q</kbd>   | `livie-quit`                 | Bury the `*livie*` buffer                             |
| <kbd>s</kbd>   | `livie-search`               | Make a new search                                     |
| <kbd>></kbd>   | `livie-search-next-page`     | Go to next page                                       |
| <kbd><</kbd>   | `livie-search-previous-page` | Go to previous page                                   |
| <kbd>t</kbd>   | `livie-search-type`          | Change the type of results (videos, playlists, etc.). |
| <kbd>S</kbd>   | `livie-sort-videos`          | Sort videos on the current buffer.                    |
| <kbd>Y</kbd>   | `livie-yank-channel-feed`    | Copy the channel RSS feed for the current entry       |
| <kbd>RET</kbd> | `livie-open-entry`           | Open entry                                            |
| <key>y</key>   | `livie-watch-this-video`     | Play video                                            |
